Subject: Re: [v6ops] Thinking about problems in IPv6-only networks

From: Brian E Carpenter <[email-masked]>
Date: Tue, 2 Oct 2018 08:35:01 +1300

Hi Fernando,
On 2018-09-29 21:11, Fernando Gont wrote:
> Hello, Brian,
> 
> On 09/04/2018 04:03 AM, Brian E Carpenter wrote:
> [...]
>>>
>>>> Any node that emits IPv4 traffic when the bit
>>>> is set is either a legacy host or a dual stack host that's not entered
>>>> a v6-only mode. So that means it's a host worth checking as part of
>>>> the v6-only test.
>>>>
>>>> **"Dual stack hosts that have a good reason to use IPv4, for example for
>>>>    a specific IPv4 link-local service, can continue to do so.  This is
>>>>    consistent with the SHOULD language in this document."
>>>
>>> But... is that IPv6 only? At the end of the day, it would seem that for
>>> most home and enterprise networks, you will always have a reason for
>>> doing some IPv4.. so I wonder when one would see this bit have practical
>>> effect. -- most enterprise and home networks will normally do DNS-SD or
>>
>> DNS-SD works for IPv6 too afaik
> 
> Appolgies if my comment was misleading/sloppy -- I meant, in general:
> they do deal with devices that are IPv4-only.
> 
> 
> 
>>> LLMNR, and associated sevices. Also, think about e.g. printers that are
>>> likely going to remain IPv4-only till they eventually beak and get replaced.
>>
>> Indeed. This is a long-term play; I would expect that if the IPv6only bit is
>> approved and deployed, it will become increasingly relevant as the legacy
>> nodes slowly vanish. And at the end it will become irrelevant again.
> 
> Apologies if this has already been discussed, and I just missed it:
> 
> I envision two alternatives:
> 
> 1) "the network/router knows better", and then reaction to the IPv6-only
> flag is more of a MUST (well, could be a "SHOULD", but certainly not
> with a clause that is expected to be common.. otherwise it's not an
> "exception", but rather a rule :-) ). That way, the flag could
> indeed disable IPv4 on the network.
> 
> 2) "end hosts know better", and reaction to the flag becomes kind of a
> "MAY". And I'm not sure to what extent the flag will have much of a
> practical effect on networks. -- particularly when the hosts don't
> really "know better" -- the best they can do is "keep trying"... whether
> for actually getting an IPv4 address and/or for things like DNS-SD.

Both are correct! That is exactly why draft-ietf-6man-ipv6only-flag-02
uses SHOULD but notes that exceptions to the SHOULD apply in cases where
the end host knows better ;-). In fact that's quite precisely what
SHOULD means in RFC2119: do this unless you know better.

   Brian